using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Wiz.FileSyncer.Forms
{
	public partial class FileSyncer : Form
	{
		#region []
		private Wiz.FileSyncer.Configs cfg = new Wiz.FileSyncer.Configs();
		private Wiz.FileSyncer.ProjectLoder proj = new Wiz.FileSyncer.ProjectLoder();
		private Wiz.FileSyncer.Syncer syncer = new Wiz.FileSyncer.Syncer();
		private string projPath = "";

		private string[] logFormat = {
			"###[{0}] ũ  #################################################################",
			"˻ ׸ : üũ[{0}] ߰[{1}] [{2}] [{3}] #",
			"[{0}]\t{1}",
			"###[{0}] ũ Ϸ #################################################################"
		};

		// private bool optionChanged = false;
		private bool projectChanged = false;
		#endregion

		#region [Ӽ]
		private int selIdx
		{
			get { return this.projItemList.SelectedIndex; }
		}
		#endregion

		#region []
		public FileSyncer()
		{
			InitializeComponent();
			this.syncer.OnSearchStart += new Syncer.StateMsgEvent(syncer_OnSearchStart);
			this.syncer.OnSearchUpdate += new Syncer.StateEvent(syncer_OnSearchUpdate);
			this.syncer.OnSearchFinish += new Syncer.StateMsgEvent(syncer_OnSearchFinish);
			this.syncer.OnSyncStart += new Syncer.StateMsgEvent(syncer_OnSyncStart);
			this.syncer.OnSyncUpdate += new Syncer.StateMsgEvent(syncer_OnSyncUpdate);
			this.syncer.OnSyncFinish += new Syncer.StateMsgEvent(syncer_OnSyncFinish);
			this.syncer.OnSyncerError += new Syncer.StateMsgEvent(syncer_OnSyncerError);
			LoadConfig();
		}
		#endregion

		#region [̺Ʈ] Ʈâ
		#region [̺Ʈ][projOpen_Click]
		private void projOpen_Click(object sender, EventArgs e)
		{
			if (this.openProjDlg.ShowDialog(this) == DialogResult.OK)
			{
				loadProjectFile(this.openProjDlg.FileName);
				SaveConfigPath();
				projectChanged = false;
			}
		}
		#endregion

		#region [̺Ʈ][projSave_Click]
		private void projSave_Click(object sender, EventArgs e) { saveProjectFile(false); }
		#endregion

		#region [̺Ʈ][projSaveAs_Click]
		private void projSaveAs_Click(object sender, EventArgs e) { saveProjectFile(true); }
		#endregion

		#region [̺Ʈ][projName_TextChanged]
		private void projName_TextChanged(object sender, EventArgs e) { projectChanged = true; }
		#endregion

		#region [̺Ʈ][btnStart_Click]
		private void btnStart_Click(object sender, EventArgs e)
		{
			if (this.syncer.IsWorking)
			{
				string msg = "ڿ  ũ Ǿϴ.";
				this.writeState(msg);
				this.writeLog(msg);
				this.syncer.StopProcess();
			}
			else
			{
				if (loopRun.Checked) { this.runProject(); }	// ݺ 
				else { this.runProjectOneTime(); }	// ѹ 
			}
		}
		#endregion

		#region [̺Ʈ][projItemList_ItemCheck]
		private void projItemList_ItemCheck(object sender, ItemCheckEventArgs e)
		{
			this.proj.SyncProj.ListItems[e.Index].IsSyncItem = e.NewValue;
		}
		#endregion
		#endregion

		#region [̺Ʈ] Ʈ
		#region [̺Ʈ][FileSyncer_MinimumSizeChanged]
		private void FileSyncer_MinimumSizeChanged(object sender, EventArgs e)
		{
			this.Visible = false;
		}
		#endregion

		#region [̺Ʈ][nIcon_MouseDoubleClick]
		private void nIcon_MouseDoubleClick(object sender, MouseEventArgs e)
		{
			this.WindowState = FormWindowState.Normal;
			this.Visible = true; this.Activate(); base.Focus();
		}
		#endregion

		#region [̺Ʈ][nIcon_MouseDown]
		private void nIcon_MouseDown(object sender, MouseEventArgs e)
		{
			this.WindowState = FormWindowState.Normal;
			this.Visible = true; base.Activate(); base.Focus();
		}
		#endregion

		#region [̺Ʈ][cmNIconEnd_Click]
		private void cmNIconEnd_Click(object sender, EventArgs e)
		{
			this.Close();
		}
		#endregion

		#region [̺Ʈ][cmNIconHelp_Click]
		private void cmNIconHelp_Click(object sender, EventArgs e)
		{
		}
		#endregion

		#region [̺Ʈ][cmNIconAbout_Click]
		private void cmNIconAbout_Click(object sender, EventArgs e)
		{
			Wiz.FileSyncer.Forms.AboutBox ab = new Wiz.FileSyncer.Forms.AboutBox();
			ab.ShowDialog(this);
			ab.Dispose();
		}
		#endregion
		#endregion

		#region [̺Ʈ] ɼâ
		#region [̺Ʈ][loadLastProj_CheckedChanged]
		private void loadLastProj_CheckedChanged(object sender, EventArgs e) { SaveConfigPath();SaveConfig(); }
		#endregion

		#region [̺Ʈ][saveLog_CheckedChanged]
		private void saveLog_CheckedChanged(object sender, EventArgs e) { SaveConfig(); }
		#endregion

		#region [̺Ʈ][loopRun_CheckedChanged]
		private void loopRun_CheckedChanged(object sender, EventArgs e) { SaveConfig(); }
		#endregion
		#endregion

		#region [̺Ʈ] â
		#region [̺Ʈ][pItemAdd_Click]
		private void pItemAdd_Click(object sender, EventArgs e)
		{
			Wiz.FileSyncer.Entity.ListItem lItem = getItemInfo();
			int nidx = this.projItemList.Items.Count;
			lItem.ItemName = ("׸" + nidx.ToString());
			if (this.proj.AddItem(lItem)) { this.RefreshList(); }
			this.projItemList.SelectedIndex = nidx;
		}
		#endregion

		#region [̺Ʈ][pItemDel_Click]
		private void pItemDel_Click(object sender, EventArgs e)
		{
			//  ׸ 
			if (this.projItemList.SelectedIndex >= 0)
			{
				int sidx = this.projItemList.SelectedIndex;
				if (this.proj.SyncProj.ListItems != null && this.proj.SyncProj.ListItems.Count >= sidx)
				{
					this.proj.SyncProj.DeleteItem(sidx);
					this.RefreshList();
					projectChanged = true;
				}
			}
		}
		#endregion

		#region [̺Ʈ][projItemList_SelectedIndexChanged]
		private void projItemList_SelectedIndexChanged(object sender, EventArgs e)
		{
			setItemInfo(this.projItemList.SelectedIndex);
		}
		#endregion
		#endregion

		#region [̺Ʈ] ׸  â
		#region [̺Ʈ][srcDirSel_Click]
		private void srcDirSel_Click(object sender, EventArgs e)
		{
			if (this.srcDirBrw.ShowDialog(this) == DialogResult.OK)
			{
				this.srcDirPath.Text = srcDirBrw.SelectedPath;
				if (!this.srcDirPath.Text.EndsWith("\\")) { this.srcDirPath.Text += "\\"; }
			}
		}
		#endregion

		#region [̺Ʈ][trgDirSel_Click]
		private void trgDirSel_Click(object sender, EventArgs e)
		{
			if (this.trgDirBrw.ShowDialog(this) == DialogResult.OK)
			{
				this.trgDirPath.Text = trgDirBrw.SelectedPath;
				if (!this.trgDirPath.Text.EndsWith("\\")) { this.trgDirPath.Text += "\\"; }
			}
		}
		#endregion

		#region [̺Ʈ][orderUP_Click]
		private void orderUP_Click(object sender, EventArgs e)
		{
			if (selIdx < 0) { return; }
			if (this.proj.SyncProj.OrderUP(selIdx))
			{
				this.RefreshList();
				this.projItemList.SelectedIndex = (selIdx - 1);
				projectChanged = true;
			} 
		}
		#endregion

		#region [̺Ʈ][orderDN_Click]
		private void orderDN_Click(object sender, EventArgs e)
		{
			if (selIdx < 0) { return; }
			if (this.proj.SyncProj.OrderDN(selIdx))
			{
				this.RefreshList();
				this.projItemList.SelectedIndex = (selIdx + 1);
				projectChanged = true;
			}
		}
		#endregion

		#region [̺Ʈ][itemName_TextChanged]
		private void itemName_TextChanged(object sender, EventArgs e)
		{
			if (selIdx < 0) { return; }
			//  Ʈ
			//if (string.IsNullOrEmpty(this.itemName.Text)) { this.itemName.Text = "̸" + this.selIdx.ToString(); }
			if (this.proj.SyncProj.ListItems[selIdx].ItemName != this.itemName.Text)
			{
				this.proj.SyncProj.ListItems[selIdx].ItemName = this.itemName.Text;
				projectChanged = true;
				this.RefreshList();
			}
		}
		#endregion

		#region [̺Ʈ][srcDirPath_TextChanged]
		private void srcDirPath_TextChanged(object sender, EventArgs e)
		{
			if (selIdx < 0) { return; }
			// ҽּ Ʈ
			if (this.proj.SyncProj.ListItems[selIdx].SourcePath != this.srcDirPath.Text)
			{
				if (!this.srcDirPath.Text.EndsWith("\\")) { this.srcDirPath.Text += "\\"; }
				this.proj.SyncProj.ListItems[selIdx].SourcePath = this.srcDirPath.Text;
				projectChanged = true;
			}
		}
		#endregion

		#region [̺Ʈ][trgDirPath_TextChanged]
		private void trgDirPath_TextChanged(object sender, EventArgs e)
		{
			if (selIdx < 0) { return; }
			// Ÿ ּ Ʈ
			if (this.proj.SyncProj.ListItems[selIdx].TargetPath != this.trgDirPath.Text)
			{
				if (!this.trgDirPath.Text.EndsWith("\\")) { this.trgDirPath.Text += "\\"; }
				this.proj.SyncProj.ListItems[selIdx].TargetPath = this.trgDirPath.Text;
				projectChanged = true;
			}
		}
		#endregion

		#region [̺Ʈ][createAllow_CheckedChanged]
		private void createAllow_CheckedChanged(object sender, EventArgs e)
		{
			if (selIdx < 0) { return; }
			//  ׸ ȭ üũ
			if (this.proj.SyncProj.ListItems[selIdx].CreateAllow != this.createAllow.Checked)
			{
				this.proj.SyncProj.ListItems[selIdx].CreateAllow = this.createAllow.Checked;
				projectChanged = true;
			}
		}
		#endregion

		#region [̺Ʈ][changeAllow_CheckedChanged]
		private void changeAllow_CheckedChanged(object sender, EventArgs e)
		{
			if (selIdx < 0) { return; }
			//  ׸ ȭ üũ
			if (this.proj.SyncProj.ListItems[selIdx].ChangeAllow != this.changeAllow.Checked)
			{
				this.proj.SyncProj.ListItems[selIdx].ChangeAllow = this.changeAllow.Checked;
				projectChanged = true;
			}
		}
		#endregion

		#region [̺Ʈ][deleteAllow_CheckedChanged]
		private void deleteAllow_CheckedChanged(object sender, EventArgs e)
		{
			if (selIdx < 0) { return; }
			//  ׸ ȭ üũ
			if (this.proj.SyncProj.ListItems[selIdx].DeleteAllow != this.deleteAllow.Checked)
			{
				this.proj.SyncProj.ListItems[selIdx].DeleteAllow = this.deleteAllow.Checked;
				projectChanged = true;
			}
		}
		#endregion

		#region [̺Ʈ][syncType1_CheckedChanged]
		private void syncType1_CheckedChanged(object sender, EventArgs e)
		{
			if (selIdx < 0) { return; }
			// ũ Ÿ Ʈ
			if (this.syncType1.Checked && this.proj.SyncProj.ListItems[selIdx].SyncType != 1)
			{
				setSyncTypeForm(1);
				this.proj.SyncProj.ListItems[selIdx].SyncType = 1;
				projectChanged = true;
			}
		}
		#endregion

		#region [̺Ʈ][syncType2_CheckedChanged]
		private void syncType2_CheckedChanged(object sender, EventArgs e)
		{
			if (selIdx < 0) { return; }
			if (this.syncType2.Checked && this.proj.SyncProj.ListItems[selIdx].SyncType != 2)
			{
				// ũ Ÿ Ʈ
				setSyncTypeForm(2);
				this.proj.SyncProj.ListItems[selIdx].SyncType = 2;
				projectChanged = true;
			}
		}
		#endregion

		#region [̺Ʈ][sDTP_ValueChanged]
		private void sDTP_ValueChanged(object sender, EventArgs e)
		{
			if (selIdx < 0) { return; }
			if (this.proj.SyncProj.ListItems[selIdx].SyncSDate != this.sDTP.Value)
			{
				this.proj.SyncProj.ListItems[selIdx].SyncSDate = this.sDTP.Value;
				if (this.sDTP.Enabled && this.proj.SyncProj.ListItems[selIdx].SyncType == 2) { projectChanged = true; }
			}
		}
		#endregion

		#region [̺Ʈ][eDTP_ValueChanged]
		private void eDTP_ValueChanged(object sender, EventArgs e)
		{
			if (selIdx < 0) { return; }
			if (this.proj.SyncProj.ListItems[selIdx].SyncEDate != this.eDTP.Value)
			{
				this.proj.SyncProj.ListItems[selIdx].SyncEDate = this.eDTP.Value;
				if (this.eDTP.Enabled && this.proj.SyncProj.ListItems[selIdx].SyncType == 2) { projectChanged = true; }
			}
		}
		#endregion

		#region [̺Ʈ][eDTTday_CheckedChanged]
		private void eDTTday_CheckedChanged(object sender, EventArgs e)
		{
			if (selIdx < 0) { return; }
			if (this.proj.SyncProj.ListItems[selIdx].SyncEDateToday != this.eDTTday.Checked)
			{
				this.deleteAllow.Enabled = !this.eDTTday.Checked;
				this.proj.SyncProj.ListItems[selIdx].SyncEDateToday = this.eDTTday.Checked;
				this.eDTP.Value = System.DateTime.Now;
				if (this.eDTTday.Enabled && this.proj.SyncProj.ListItems[selIdx].SyncType == 2) { projectChanged = true; }
			}
		}
		#endregion
		#endregion
		
		#region [̺Ʈ] syncer ̺Ʈ ******
		#region [̺Ʈ][syncer_OnSearchStart]
		private void syncer_OnSearchStart(string msg)
		{
			writeState(msg);
			if(this.cfg.GetLastCnt() > 0) { this.syncProgressBar.Maximum = this.cfg.LastCnt; }
			this.syncProgressBar.Value = 0;
		}
		#endregion

		#region [̺Ʈ][syncer_OnSearchUpdate]
		private void syncer_OnSearchUpdate()
		{
			this.cntSET.Text = syncer.CntSET.ToString("#,#");
			this.cntSEN.Text = syncer.CntSEN.ToString("#,#");
			this.cntSEU.Text = syncer.CntSEU.ToString("#,#");
			this.cntSED.Text = syncer.CntSED.ToString("#,#");
			if(this.syncProgressBar.Maximum >= this.syncer.CntSET) { this.syncProgressBar.Value = this.syncer.CntSET; }
			refleshPannel();
		}
		#endregion

		#region [̺Ʈ][syncer_OnSearchFinish]
		private void syncer_OnSearchFinish(string msg)
		{
			writeState(msg);
			this.cfg.SetLastCnt(this.syncer.CntSET);
			writeLog(string.Format(logFormat[1], syncer.CntSET.ToString(), syncer.CntSEN.ToString(), syncer.CntSEU.ToString(), syncer.CntSED.ToString()));
		}
		#endregion

		#region [̺Ʈ][syncer_OnSyncStart]
		private void syncer_OnSyncStart(string msg)
		{
			this.cntSYT.Text = syncer.CntSYT.ToString("#,#");
			writeState(msg);
			this.syncProgressBar.Maximum = 100;
			this.syncProgressBar.Value = 0;
		}
		#endregion

		#region [̺Ʈ][syncer_OnSyncUpdate]	
		private void syncer_OnSyncUpdate(string msg)
		{
			this.cntSYE.Text = syncer.CntSYE.ToString("#,#");
			this.cntSYR.Text = syncer.CntSYR.ToString("#,#");
			writeLog(string.Format(logFormat[2], System.DateTime.Now.ToString("yyyy.MM.dd HH:mm:ss"), msg));
			if (this.syncer.CntSYT > 0 && this.syncer.CntSYR <= this.syncer.CntSYT) { this.syncProgressBar.Value = (int)(((float)this.syncer.CntSYR / (float)this.syncer.CntSYT) * 100); }
			refleshPannel();
		}
		#endregion

		#region [̺Ʈ][syncer_OnSyncFinish]
		private void syncer_OnSyncFinish(string msg)
		{
			writeState(msg);
			writeLog(string.Format(logFormat[3], System.DateTime.Now.ToString("yyyy.MM.dd HH:mm:ss")));
			this.syncProgressBar.Value = 100;
		}
		#endregion

		#region [̺Ʈ][syncer_OnSyncerError]
		private void syncer_OnSyncerError(string msg)
		{
			this.cntSYE.Text = syncer.CntSYE.ToString("#,#");
			writeState("Error : [" + System.DateTime.Now.ToString("yyyy.MM.dd HH:mm:ss") + "] " + msg);
			writeLog("Error : [" + System.DateTime.Now.ToString("yyyy.MM.dd HH:mm:ss") + "] " + msg);
		}
		#endregion
		#endregion

		#region [Լ]
		#region [Լ][RefreshList]
		/// <summary>Ʈ ΰħ</summary>
		private void RefreshList()
		{
			if (null != this.proj)
			{
				if (null != this.proj.SyncProj.ProjConfig)
				{
					if (null != this.proj.SyncProj.ProjConfig.ProjectName)
					{ this.projName.Text = this.proj.SyncProj.ProjConfig.ProjectName; }
				}

				if (null != this.proj.SyncProj.ListItems)
				{
					int oIdx = -1;
					if (this.selIdx >= 0) { oIdx = this.selIdx;  }
					this.projItemList.Items.Clear();
					int cnt = this.proj.SyncProj.ListItems.Count;
					for (int tmpi = 0; tmpi < cnt; tmpi++)
					{ this.projItemList.Items.Add(this.proj.SyncProj.ListItems[tmpi].ItemName, this.proj.SyncProj.ListItems[tmpi].IsSyncItem); }
					if (oIdx >= 0) { this.projItemList.SelectedIndex = oIdx; }
				}
			}
		}
		#endregion

		#region [Լ][writeState]
		/// <summary> ޼ Ѵ.</summary>
		/// <param name="msg">޼</param>
		private void writeState(string msg)
		{
			this.pState.Text = msg;
		}
		#endregion

		#region [Լ][refleshPannel]
		private int rfCnt = 0;
		private void refleshPannel()
		{
			if (rfCnt > 20) { resultPanel.Refresh(); }
			if (rfCnt > 80) { this.Refresh(); rfCnt = 0; }
			rfCnt++;
		}
		#endregion

		#region [Լ][resetCount]
		private void resetCount()
		{
			this.cntSET.Text = "0";
			this.cntSEN.Text = "0";
			this.cntSEU.Text = "0";
			this.cntSED.Text = "0";
			this.cntSYT.Text = "0";
			this.cntSYR.Text = "0";
			this.cntSYE.Text = "0";
		}
		#endregion
		#endregion

		#region [Լ] ũ
		#region [Լ][writeLog]
		private void writeLog(string msg)
		{
			if (this.cfg.SaveLog)
			{
				string fp = (System.Windows.Forms.Application.StartupPath + "\\Log\\");
				if (!System.IO.Directory.Exists(fp)) { System.IO.Directory.CreateDirectory(fp); }
				fp += ("FileSyncerLog_" + System.DateTime.Now.ToString("yyyyMMdd_HHMM") + ".log");
				Wiz.AF.IO.File.LogWriter.WriteLog(fp, msg);
			}
		}
		#endregion

		#region [Լ][runProject]
		/// <summary>Ʈ </summary>
		private void runProject()
		{
			this.resetCount();
			setButtonState(true);
			do
			{
				this.syncer.ReSet();
				this.syncer.RunSync(this.proj.SyncProj.ListItems, true);
				System.Windows.Forms.Application.DoEvents();
			} while (this.syncer.IsWorking);
			setButtonState(false);
		}
		#endregion

		#region [Լ][runProjectOneTime]
		/// <summary>Ʈ ѹ </summary>
		private void runProjectOneTime()
		{
			this.resetCount();
			setButtonState(true);
			this.syncer.ReSet();
			this.syncer.RunSync(this.proj.SyncProj.ListItems, false);
			setButtonState(false);
		}
		#endregion

		#region [Լ][setButtonState]
		/// <summary>/  ư </summary>
		/// <param name="isRunning"> </param>
		private void setButtonState(bool isRunning)
		{
			this.btnStart.Text = (isRunning ? "" : "");
			this.prjPannel.Enabled = !isRunning;
		}
		#endregion
		#endregion

		#region [Լ] Ʈ/׸  
		#region [Լ][loadProjectFile]
		/// <summary>Ʈ о ´</summary>
		/// <param name="filePath"> </param>
		private void loadProjectFile(string filePath)
		{
			this.proj = new Wiz.FileSyncer.ProjectLoder();
			this.proj.LoadFromFile(filePath);
			if (proj.SyncProj.ProjConfig != null)
			{
				if (proj.SyncProj.ProjConfig.ProjectName != null) { this.projName.Text = proj.SyncProj.ProjConfig.ProjectName; }
				this.projPath = filePath;
			}
			this.RefreshList();
		}
		#endregion

		#region [Լ][saveProjectFile]
		/// <summary>Ʈ о ´</summary>
		private void saveProjectFile(bool isNewFileSave)
		{
			if (isNewFileSave || string.IsNullOrEmpty(this.projPath))
			{
				// Ʈ    
				if (this.saveProjDlg.ShowDialog(this) == DialogResult.OK) { SaveConfigPath(); }	// Ʈ    
			}
			//else
			//{
			//    if (System.IO.File.Exists(this.projPath))
			//    {
			//        System.Windows.Forms.DialogResult dr = System.Windows.Forms.MessageBox.Show("   Ͻðڽϱ?", "", System.Windows.Forms.MessageBoxButtons.YesNo);
			//        if (dr == DialogResult.No)
			//        {
			//            getProjSaveFilePath();
			//            SaveConfigPath();	// Ʈ    
			//        }
			//    }
			//}	//  

			if (string.IsNullOrEmpty(this.projName.Text)) { this.projName.Text = "̸"; }
			if (!string.IsNullOrEmpty(this.projPath))
			{
				this.proj.SaveToFile(this.projPath, this.projName.Text);
				this.RefreshList();
				projectChanged = false;
			}
		}
		#endregion

		#region [Լ][setSyncTypeForm]
		/// <summary>ũ ŸԿ   </summary>
		/// <param name="syncType">ũ Ÿ</param>
		private void getProjSaveFilePath()
		{
			// Ʈ    
			if (this.saveProjDlg.ShowDialog(this) == DialogResult.OK)
			{
				this.projPath = this.saveProjDlg.FileName;
				SaveConfigPath();
			}
		}
		#endregion

		#region [Լ][setSyncTypeForm]
		/// <summary>ũ ŸԿ   </summary>
		/// <param name="syncType">ũ Ÿ</param>
		private void setSyncTypeForm(int syncType)
		{
			switch (syncType)
			{
				////case 3:
				////    this.sDTP.Enabled = false;
				////    this.eDTP.Enabled = false;
				////    this.createAllow.Enabled = true;
				////    this.changeAllow.Enabled = true;
				////    this.deleteAllow.Enabled = false;
				////    this.eDTTday.Enabled = false;
				////    break;
				case 2:
					this.sDTP.Enabled = true;
					this.eDTP.Enabled = true;
					this.createAllow.Enabled = false;
					this.changeAllow.Enabled = false;
					this.eDTTday.Enabled = true;
					this.deleteAllow.Enabled = !this.eDTTday.Checked;
					break;
				default:
				case 1:
					this.sDTP.Enabled = false;
					this.eDTP.Enabled = false;
					this.createAllow.Enabled = true;
					this.changeAllow.Enabled = true;
					this.deleteAllow.Enabled = true;
					this.eDTTday.Enabled = false;
					break;
			}
		}
		#endregion

		#region [Լ][setItemInfo]
		/// <summary> ε</summary>
		/// <param name="itemIndex">ε</param>
		private void setItemInfo(int itemIndex)
		{
			if (null != this.proj)
			{
				if (null != this.proj.SyncProj.ListItems)
				{
					if (itemIndex >= 0 && null != this.proj.SyncProj.ListItems[itemIndex])
					{
						Wiz.FileSyncer.Entity.ListItem li = this.proj.SyncProj.ListItems[itemIndex];

						this.itemName.Text = li.ItemName;
						this.srcDirPath.Text = li.SourcePath;
						this.trgDirPath.Text = li.TargetPath;
						this.createAllow.Checked = li.CreateAllow;
						this.deleteAllow.Checked = li.DeleteAllow;
						this.changeAllow.Checked = li.ChangeAllow;

						switch (li.SyncType)
						{
							//////case 3:
							//////    this.syncType1.Checked = true;
							//////    this.sDTP.Value = DateTime.Now;
							//////    this.eDTP.Value = DateTime.Now;
							//////    this.eDTTday.Checked = false;
							//////    break;
							case 2:
								this.syncType2.Checked = true;
								this.sDTP.Value = li.SyncSDate;

								this.eDTTday.Checked = li.SyncEDateToday;
								if (li.SyncEDateToday) { this.eDTP.Value = DateTime.Now; }
								else { this.eDTP.Value = li.SyncEDate; }
								break;
							default:
							case 1:
								this.syncType1.Checked = true;
								this.sDTP.Value = DateTime.Now;
								this.eDTP.Value = DateTime.Now;
								this.eDTTday.Checked = false;
								break;
						}
						setSyncTypeForm(li.SyncType);
					}
					else { setItemInfoClear(); }
				}
			}
		}
		#endregion

		#region [Լ][setItemInfoClear]
		private void setItemInfoClear()
		{
			this.itemName.Text = "";
			this.srcDirPath.Text = "";
			this.trgDirPath.Text = "";
			this.createAllow.Checked = true;
			this.deleteAllow.Checked = false;
			this.changeAllow.Checked = true;
			this.syncType1.Checked = true;
			this.sDTP.Value = DateTime.Now;
			this.eDTP.Value = DateTime.Now;
			this.eDTTday.Checked = false;
		}
		#endregion

		#region [Լ][getItemInfo]
		/// <summary>Ǿ ִ ׸   ش.</summary>
		/// <returns>׸ </returns>
		private Wiz.FileSyncer.Entity.ListItem getItemInfo()
		{
			Wiz.FileSyncer.Entity.ListItem lItem = new Wiz.FileSyncer.Entity.ListItem();
			lItem = new Wiz.FileSyncer.Entity.ListItem();
			lItem.ItemName = this.itemName.Text;
			if(!this.srcDirPath.Text.EndsWith("\\")) { this.srcDirPath.Text += "\\"; }
			if(!this.trgDirPath.Text.EndsWith("\\")) { this.trgDirPath.Text += "\\"; }
			lItem.SourcePath = this.srcDirPath.Text;
			lItem.TargetPath = this.trgDirPath.Text;

			if (this.syncType2.Checked)
			{
				lItem.SyncType = 2;
				lItem.CreateAllow = true;
				lItem.ChangeAllow = true;
				lItem.DeleteAllow = false;
				lItem.SyncSDate = this.sDTP.Value;
				lItem.SyncEDateToday = this.eDTTday.Checked;
				if (this.eDTTday.Checked) { lItem.SyncEDate = DateTime.Now; }
				else { lItem.SyncEDate = this.eDTP.Value; }
			}
			else	// if (this.syncType1.Checked)
			{
				lItem.SyncType = 1;
				lItem.CreateAllow = this.createAllow.Checked;
				lItem.ChangeAllow = this.changeAllow.Checked;
				lItem.DeleteAllow = this.deleteAllow.Checked;
				lItem.SyncSDate = DateTime.Now;
				lItem.SyncEDate = DateTime.Now;
				lItem.SyncEDateToday = false;
			}
			//////else
			//////{
			//////    lItem.SyncType = 1;
			//////    lItem.CreateAllow = this.createAllow.Checked;
			//////    lItem.ChangeAllow = this.changeAllow.Checked;
			//////    lItem.DeleteAllow = false;
			//////    lItem.SyncSDate = DateTime.Now;
			//////    lItem.SyncEDate = DateTime.Now;
			//////    lItem.SyncEDateToday = false;
			//////}
			return lItem;
		}
		#endregion
		#endregion

		#region [Լ] ɼǰ
		#region [Լ][LoadConfig]
		private void LoadConfig()
		{
			IsInConfigLod = true;
			cfg.LoadConfig();
			this.loadLastProj.Checked = cfg.LoadLastProj;
			this.saveLog.Checked	= cfg.SaveLog;
			this.loopRun.Checked	= cfg.LoopRun;

			// ɼǿ о´.    Ʈ δ 
			if (this.cfg.LoadLastProj)
			{
				loadProjectFile(cfg.LastProjFileName);
				projectChanged = false;
			}
			else { this.proj = new Wiz.FileSyncer.ProjectLoder(); }
			IsInConfigLod = false;
		}
		#endregion

		private bool IsInConfigLod = false;
		#region [Լ][SaveConfig]
		private void SaveConfig()
		{
			if (!IsInConfigLod)
			{
				cfg.SaveLog = this.saveLog.Checked;
				cfg.LoadLastProj = this.loadLastProj.Checked;
				cfg.LoopRun = this.loopRun.Checked;
				cfg.SaveConfig();
			}
		}
		#endregion

		#region [Լ][SaveConfig]
		private void SaveConfigPath()
		{
			if (!IsInConfigLod)
			{
				if (this.loadLastProj.Checked && !string.IsNullOrEmpty(this.projPath))
				{
					cfg.SaveConfigLastProjFileName(this.projPath);
				}
			}
		}
		#endregion
		#endregion
	}
}